Subject: Re: [PATCH 2/3] Allow isatty to be overriden with GIT_FORCE_TTY

From: Junio C Hamano <[email-masked]>
Date: Tue, 06 Jul 2021 15:03:49 -0700

Avishay Matayev <[email-masked]> writes:

> There are several behaviors where git will not attempt to do an action if a
> tty is not present, for example - `git_pager` (pager.c) will instruct git
> to not use the GIT_PAGER environment variable if stdout is not a pty.

In general, I am negative on this approach, even though I agree that
the issue you are trying to solve is worth solving.  "Force pretend
that we are talking to a TTY" exposes too much of the internal
logic in the implementation to the end users.

Often we use isatty() as an approximation for "are we being
interactive?", and I wouldn't have as much problem as I have with
the "FORCE_TTY" to an approach to give users a knob to tell us "do
not use your logic to guess---I am telling you that we are
interactive, so behave as such".